<%@ page contentType="text/html; charset=utf-8" %>
<%@ page language="java" %>
<% try { // START: DEBUG %>
<%@ page errorPage="/errorPage.jsp" %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/citation.tld" prefix="citation" %>

<html:xhtml />
<%@ page import="com.sas.apps.citation.controller.action.report.filter.section.PromptManagerAction" %>
<%@ page import="com.sas.apps.citation.model.user.SessionScopeManager" %>
<%@ page import="com.sas.apps.citation.util.CommonUtils" %>
<%@ page import="com.sas.apps.citation.view.beans.PagePropertyBean" %>
<%@ page import="com.sas.apps.citation.view.beans.filterrank.section.CascadingFilterRule" %>
<%@ page import="com.sas.apps.citation.view.beans.filterrank.section.PromptManagerForm" %>
<%@ page import="com.sas.apps.citation.view.beans.filterrank.section.PromptManagerFormProcessor" %>
<%@ page import="com.sas.apps.citation.view.beans.filterrank.section.FormFilterInterface" %>
<%@ page import="com.sas.apps.citation.view.beans.filterrank.section.FormPromptInterface" %>
<%@ page import="com.sas.apps.citation.view.help.HelpUtils" %>
<%@ page import="com.sas.apps.citation.view.tbeans.html.CitationButton" %>
<%@ page import="com.sas.apps.citation.view.util.PageErrorProcessor" %>

<%@ page import="com.sas.servlet.tbeans.StyleInfo" %>
<%@ page import="com.sas.servlet.tbeans.form.html.OrderedListBoxView" %>

<%
    Object rc = request.getAttribute(PromptManagerAction.RESULT_CODE_KEY);
    Object cmdKey = request.getAttribute(PromptManagerAction.DIALOG_CMD_KEY);
    if( PromptManagerAction.RC_SUCCESS.equals(rc)
        && PromptManagerAction.CMD_OK_DIALOG_KEY.equals(cmdKey))
    { 
    // #############################################
%>
<script type="text/javascript"> /*<![CDATA[*/
    cwDialogManager.closeSelf();
/*]]>*/ </script>
<%
        return; //fast return from service method
    } //if( ManagePromptsAction.RC_SUCCESS.equals(rc)
            
  SessionScopeManager smgr = SessionScopeManager.getSessionScopeManager(request);

%>
<jsp:useBean id="managePromptsForm" class="com.sas.apps.citation.view.beans.filterrank.section.PromptManagerForm" scope="session" />
<%
    String formName = "managePromptsForm";
    String dialogId = "promptManager";
    String dialogRefId = "g_promptManagerDialog"; //Qualifier in the event this dlg needs to be embedded elsewhere 
    String cascadingPromptChooserId = dialogId + "_cascadingPromptChooser";
    String rootFilterChooserId = dialogId + "_rootFilterChooser";
    String addRuleButtonId = dialogId+"addRuleButton";
    String removeRuleButtonId = dialogId+"removeRuleButton";
%>
<script type="text/javascript" src="scripts/citation_listTools.js"></script>
<script type="text/javascript" src="scripts/citation_promptManager.js"></script>
<script type="text/javascript"> /*<![CDATA[*/
<%--
//Declare dialog variable that allows us to give scope to other variables
--%>
var <%=dialogRefId%> = new PromptManagerDialog();
/*]]>*/ </script>

<%
// +++++++ construct dialog buttons (ok, cancel, help) +++++++
CitationButton okButton = CitationButton.createStandaloneButton(request, "okButton",
    PagePropertyBean.getLabelWithMnemonic(pageContext,"ok.button.txt"),
    dialogRefId + ".onDialogOk();"
    );
request.setAttribute(CitationButton.OK_DIALOG_BUTTON, okButton);

CitationButton cancelButton = CitationButton.createStandaloneButton(request, "cancelButton",
    PagePropertyBean.getLabelWithMnemonic(pageContext,"cancel.button.txt"),
    "cwDialogManager.cancelSelf();");
request.setAttribute(CitationButton.CANCEL_DIALOG_BUTTON, cancelButton);

HelpUtils.createHelpButton(request, HelpUtils.HELP_FILTER_MANAGE_PROMPTS);

//Add, Remove buttons
StyleInfo buttonStyle = new StyleInfo();
buttonStyle.setStyle("width: 100%;");

String buttonLabel = PagePropertyBean.getLabel(pageContext, "edit.filters.manage.prompts.add.rule.button.txt");
CitationButton addRuleButton = CitationButton.createStandaloneButton(request, addRuleButtonId, buttonLabel);
addRuleButton.setStyle(buttonStyle.getStyle());
addRuleButton.setOnClick(dialogRefId + ".onAddCascadeRule();");

buttonLabel = PagePropertyBean.getLabel(pageContext, "edit.filters.manage.prompts.remove.rule.button.txt");
CitationButton removeRuleButton = CitationButton.createStandaloneButton(request, removeRuleButtonId, buttonLabel);
removeRuleButton.setStyle(buttonStyle.getStyle());
removeRuleButton.setOnClick(dialogRefId + ".onRemoveCascadeRule();");

String cascadeDisplayStyle = (managePromptsForm.isCascadingPromptEditingAllowed()) ? "display:block" : "display:none";
%>
<citation:form action="managePrompts.do">
<html:hidden property="<%=PromptManagerAction.DIALOG_CMD_KEY %>" styleId="<%=PromptManagerAction.DIALOG_CMD_KEY %>" value="<%=PromptManagerAction.CMD_OK_DIALOG_KEY %>"/>
<div style="padding: 10px; vertical-align: top;">
<table border="0" cellpadding="0" cellspacing="0" summary="" style="width: 100%; height: 100%;">
  <tr>
    <td colspan="2" style="white-space:nowrap; vertical-align:top;">
      <fieldset class="dialogFieldset">
        <legend class="header">
           <%=PagePropertyBean.getLabel(pageContext, "edit.filters.manage.prompts.prompt.order.txt") %>
         </legend>
      <table id="promptOrder" border="0" cellpadding="0" cellspacing="0" style="width:100%;" summary="" >
      	<tr>
<% if (managePromptsForm.getOrderablePromptCount() > 0) {
%>
      	  <td style="white-space:nowrap;padding:10px;" id="promptOrderListBox">
      	     <%
      	       OrderedListBoxView promptOrderListBox = PromptManagerFormProcessor.newPromptOrderedListBox(managePromptsForm, smgr);
      	   	   promptOrderListBox.setRequest(request);
      	   	   promptOrderListBox.setResponse(response);
      	   	   promptOrderListBox.write(out);
      	     %>
      	  </td>
<% } else { // show no prompts message
%>
		  <td style="white-space:nowrap;padding:10px;" id="promptOrderListBox">
		    <div id="promptOrderDiv" class="promptOrder_messageHolder">
		      <table id="noPrompts" border="0" cellpadding="0" cellspacing="0" style="width:100%;" summary="" >
				<tr><td style="height:35px;">&nbsp;</td></tr>
		      	<tr><td class="label"><%=PagePropertyBean.getLabel(pageContext, "edit.filters.manage.prompts.noPrompts.txt") %></td></tr>
				<tr><td style="height:35px;">&nbsp;</td></tr>
		      </table>
		    </div>
		   </td>
<% }
%>
      	</tr>
      </table>
      </fieldset>
    </td>
    </tr>
	<tr><td colspan="2" class="linePadding">&nbsp;</td></tr>
    <%-- XXXXXXXXXXXXXXX Rule fields XXXXXXXXXXXXXXX --%>
    <tr>
	  <td colspan="2" style="white-space:nowrap; vertical-align:top;<%=cascadeDisplayStyle %>">
	    <fieldset class="dialogFieldset">
	      <legend class="header">
	         <%=PagePropertyBean.getLabel(pageContext, "edit.filters.manage.prompts.prompt.dependencies.txt") %>
	       </legend>
	    <table id="promptDependencies" border="0" cellpadding="0" cellspacing="0" style="width:100%;" summary="" >
	      <tr>
		    <td style="width: 49%; vertical-align: top;padding-top:10px;padding-left:10px;">
		      <table border="0" cellpadding="0" cellspacing="0" summary="" style="width:100%;">
		        <tr>
		          <td style="text-align:left;">
		            <label class="header" for="<%=cascadingPromptChooserId%>"><bean:message key="edit.filters.manage.prompts.rule.dependent.prompt.chooser.label.txt"/></label>
		          </td>
		        </tr>
		        <tr>
		          <td style="text-align:left;">
		            <html:select property="selectedCascadingPromptId" styleId="<%=cascadingPromptChooserId%>" styleClass="dropdown" style="width:100%;">
                       <%
			               int cascadablePromptCount = managePromptsForm.getCascadablePromptCount();
			               for (int i=0; i<cascadablePromptCount; i++) 
			               {
			                   FormPromptInterface cascadablePrompt = managePromptsForm.getCascadablePrompt(i);
			                   String promptLabel = cascadablePrompt.getLabel();
					           String promptId = cascadablePrompt.getId();
		               %>
		                   <html:option styleClass="dropdown" value='<%=CommonUtils.htmlEncode(promptId)%>'>
		                       <%=CommonUtils.htmlEncode(promptLabel)%>
		                   </html:option>
		               <%
		                   } 
		               %>
		            </html:select>
		          </td>
		        </tr>
		      </table>
		    </td>
		    <td style="width: 49%; vertical-align: top;padding-top:10px;padding-left:20px;padding-right:10px;">
		      <table border="0" cellpadding="0" cellspacing="0" summary="" style="width:100%;">
		        <tr>
		          <td style="text-align:left;">
		            <label class="header" for="<%=rootFilterChooserId%>"><bean:message key="edit.filters.manage.prompts.rule.prompt.dependency.chooser.label.txt"/></label>
		          </td>
		        </tr>
		        <tr>
		          <td style="text-align:left;">      
		            <html:select property="selectedRootFilterId" styleId="<%=rootFilterChooserId%>" styleClass="dropdown" style="width:100%;">
                       <%
			               int rootFilterCandidateCount = managePromptsForm.getRootFilterCandidateCount();
			               for (int i=0; i<rootFilterCandidateCount; i++) 
			               {
			                   FormFilterInterface filterCandidate = managePromptsForm.getRootFilterCandidate(i);
			                   String filterLabel = filterCandidate.getLabel();
					           String filterId = filterCandidate.getId();
		               %>
		                   <html:option styleClass="dropdown" value='<%=CommonUtils.htmlEncode(filterId)%>'>
		                       <%=CommonUtils.htmlEncode(filterLabel)%>
		                   </html:option>
		               <%
		                   } 
		               %>
		            </html:select> 
		          </td>
		        </tr>
		      </table>                 
		    </td>
          </tr>
		  <tr><td class="linePadding" colspan="2">&nbsp;</td></tr>
          <tr style="height: 50%;">
            <td colspan="2" style="padding-left:10px;padding-right:10px;padding-bottom:10px;">
              <table style="width: 100%; height: 100%;" id="<%=dialogId%>_ruleSelectionControlComposite" border="0" cellpadding="0" cellspacing="0" width="100%" summary="" >
                <tr>
             	  <td class="header" colspan="3" style="text-align: left;"><%=PagePropertyBean.getLabel(pageContext, "edit.filters.manage.prompts.dependencies.label.txt") %></td>
             	</tr>
                <tr>
                  <td style="width:80%;vertical-align:top;">
                    <div class="wrsRuleEntryContainer">
                      <table border="0" cellpadding="0" cellspacing="0" summary="" style="width: 100%; height: 100%;">
                        <tr>
                          <td> 
                            <table border="0" cellpadding="0" cellspacing="0" summary="" style="width: 100%;">
                            <tbody>
                              <tr>
                                <td class="ruleColumnHeaderStyle" style="width:225px;"><span class="header"><bean:message key="edit.filters.manage.prompts.rule.table.dependent.prompt.header.txt"/></span>
                                </td><%-- Base Prompt column header  --%>
                                <td class="ruleColumnHeaderStyle" style="padding-right:20px;"><span class="header"><bean:message key="edit.filters.manage.prompts.rule.table.prompt.dependency.header.txt"/></span>
                                </td><%-- Dependent Filter column header  --%>
                              </tr>
                            </tbody>
                            </table>
                          </td>
                        </tr>
                        <tr style="height: 92%;">
                          <td style="padding: 0px; margin: 0px; vertical-align:top;">
                            <div id="<%=dialogId%>_ruleEntryTableViewPort" class="wrsRuleEntryTableViewPort" style="height: 90px; overflow: auto;">
                            </div>
                          </td>
                        </tr>
                      </table>
                    </div>
                  </td>
                  <td class="label">&nbsp;</td>
                  <td style="vertical-align: top;">
                    <table border="0" cellpadding="0" cellspacing="0" summary="" style="width:100%;">
                      <tr><td style="padding-bottom:5px;"><% addRuleButton.write(out); %></td></tr>
                      <tr><td><% removeRuleButton.write(out); %></td></tr>
                    </table>
                  </td>
                </tr>
              </table>
            </td>
          </tr>
        </table>
      </fieldset>
    </td>
  </tr>
</table>
</div>
</citation:form>

<script type="text/javascript"> /*<![CDATA[*/
    <%=dialogRefId%>._masterFormObj = document.forms["<%=formName%>"];
    <%=dialogRefId%>._ruleEntryTableContainer = document.getElementById("<%=dialogId%>_ruleEntryTableViewPort");
    <%=dialogRefId%>._cascadingPromptChooser = document.getElementById("<%=dialogId%>_cascadingPromptChooser");
    <%=dialogRefId%>._rootFilterChooser = document.getElementById("<%=dialogId%>_rootFilterChooser");    
    <%=dialogRefId%>._addRuleButton = document.getElementById("<%=addRuleButtonId%>");
    <%=dialogRefId%>._removeRuleButton = document.getElementById("<%=removeRuleButtonId%>");    
    <%=dialogRefId%>._msgEquivalentRuleAlreadyExists = "<%= PagePropertyBean.escapeQuotes(PagePropertyBean.getLabel(pageContext, "edit.filters.manage.prompts.validate.duplicateCascadeRulesNotAllowed.txt"))%>";    
    
<%
int ruleCount = managePromptsForm.getCascadeRuleCount();
if (ruleCount > 0)
{
%>
<%
    for (int i=0; i<ruleCount; i++) 
    {
        CascadingFilterRule rule = managePromptsForm.getCascadeRule(i);
        String cascadingPromptId = rule.getCascadingPromptId();
        String escCascadingPromptId = PagePropertyBean.escapeQuotes(cascadingPromptId);
        String cascadingPromptLabel = rule.getCascadingPromptLabel();
        String escCascadingPromptLabel = PagePropertyBean.escapeQuotes(cascadingPromptLabel);
        String rootFilterId = rule.getRootFilterId();
        String escRootFilterId = PagePropertyBean.escapeQuotes(rootFilterId);
        String rootFilterLabel = rule.getRootFilterLabel();
        String escRootFilterLabel = PagePropertyBean.escapeQuotes(rootFilterLabel);
        //TODO escape encode rule properties as appropriate
%>
    <%=dialogRefId%>.addCascadeRule(<%=dialogRefId%>.newCascadeRule("<%=escCascadingPromptId%>", "<%=escCascadingPromptLabel%>", "<%=escRootFilterId%>", "<%=escRootFilterLabel%>"));
<%
    }
} 
%>
   
    <%=dialogRefId%>.initialize();
    <%=dialogRefId%>.paintRuleSelectionTable();
/*]]>*/ </script>

<% } catch (Exception ex) {
    PageErrorProcessor.setJspError(ex, pageContext, out);
} // END: DEBUG %>
